More test updates.

This commit is contained in:
Rob Landley 2006-03-16 16:02:06 +00:00
parent 4bb1b04fd1
commit 2824ded677
2 changed files with 30 additions and 26 deletions

View File

@ -4,7 +4,9 @@
[ -n "$bindir" ] || bindir=$(dirname $(pwd)) [ -n "$bindir" ] || bindir=$(dirname $(pwd))
PATH=$bindir:$PATH PATH=$bindir:$PATH
run_applet_testcase () # Run old-style test.
function run_applet_testcase
{ {
local applet=$1 local applet=$1
local testcase=$2 local testcase=$2
@ -91,6 +93,16 @@ else
applets=$(ls $srcdir) applets=$(ls $srcdir)
fi fi
# Populate a directory with links to all busybox applets
LINKSDIR="${bindir}/runtest-tempdir-links"
rm -rf "$LINKSDIR" 2>/dev/null
mkdir "$LINKSDIR"
for i in $(sed 's@/[a-z0-9/\[]*/@@' $bindir/busybox.links)
do
ln -s $bindir/busybox "$LINKSDIR"/$i
done
# Set up option flags so tests can be selective. # Set up option flags so tests can be selective.
configfile=${bindir:-../../}/.config configfile=${bindir:-../../}/.config
@ -110,25 +122,16 @@ for applet in $applets; do
applet=$(echo "$applet" | sed -n 's/\.tests$//p') applet=$(echo "$applet" | sed -n 's/\.tests$//p')
if [ ${#applet} -ne 0 ] if [ ${#applet} -ne 0 ]
then then
appcfg=`grep -i "^# CONFIG_$applet" $configfile` if [ ! -h "$LINKSDIR/$applet" ]
if [ -n "$appcfg" ]
then then
echo "SKIPPED: $applet (is configured out)" echo "SKIPPED: $applet (not built)"
continue continue
fi fi
# Setup environment for test. PATH="$LINKSDIR":$srcdir:$bindir:$PATH \
if [ -d links ]; then
rm -f links/"$applet"
else
mkdir links 2> /dev/null
fi
ln -s ${bindir:-../..}/busybox links/"$applet"
PATH="$srcdir:$PATH" COMMAND="links/$applet" \
"${srcdir:-.}/$applet".tests "${srcdir:-.}/$applet".tests
if [ $? -ne 0 ]; then status=1; fi if [ $? -ne 0 ]; then status=1; fi
fi fi
done done
rm -f links/* rm -rf "$LINKSDIR"
rmdir links
exit $status exit $status

View File

@ -15,17 +15,18 @@
# Test exit status # Test exit status
testing "seq (exit with error)" "2> /dev/null || echo yes" "yes\n" "" "" testing "seq (exit with error)" "seq 2> /dev/null || echo yes" "yes\n" "" ""
testing "seq (exit with error)" "1 2 3 4 2> /dev/null || echo yes" "yes\n" "" "" testing "seq (exit with error)" "seq 1 2 3 4 2> /dev/null || echo yes" \
testing "seq one argument" "3" "1\n2\n3\n" "" "" "yes\n" "" ""
testing "seq two arguments" "5 7" "5\n6\n7\n" "" "" testing "seq one argument" "seq 3" "1\n2\n3\n" "" ""
testing "seq two arguments reversed" "7 5" "" "" "" testing "seq two arguments" "seq 5 7" "5\n6\n7\n" "" ""
testing "seq count up by 2" "4 2 8" "4\n6\n8\n" "" "" testing "seq two arguments reversed" "seq 7 5" "" "" ""
testing "seq count down by 2" "8 -2 4" "8\n6\n4\n" "" "" testing "seq count up by 2" "seq 4 2 8" "4\n6\n8\n" "" ""
testing "seq count wrong way #1" "4 -2 8" "" "" "" testing "seq count down by 2" "seq 8 -2 4" "8\n6\n4\n" "" ""
testing "seq count wrong way #2" "8 2 4" "" "" "" testing "seq count wrong way #1" "seq 4 -2 8" "" "" ""
testing "seq count by .3" "3 .3 4" "3\n3.3\n3.6\n3.9\n" "" "" testing "seq count wrong way #2" "seq 8 2 4" "" "" ""
testing "seq count by -.9" ".7 -.9 -2.2" "0.7\n-0.2\n-1.1\n-2\n" "" "" testing "seq count by .3" "seq 3 .3 4" "3\n3.3\n3.6\n3.9\n" "" ""
testing "seq count by zero" "4 0 8 | head -n 10" "" "" "" testing "seq count by -.9" "seq .7 -.9 -2.2" "0.7\n-0.2\n-1.1\n-2\n" "" ""
testing "seq count by zero" "seq 4 0 8 | head -n 10" "" "" ""
exit $FAILCOUNT exit $FAILCOUNT